# Aufgabe 34: Unterprogramme / Primzahlberechnung
#
# von: Stephan Brumme
#
# zuletzt geaendert: 07.Juni 2000

	.data
leerzeichen: .asciiz " "

	.text
main:
	li	$s0,1			# bei 2 anfangen (die 1 wird im uebernaechsten Befehl erhoeht)
	li	$s1,100			# alle Zahlen bis 100 testen

main_loop:
	addi	$s0,$s0,1		# naechste Zahl
	bgt	$s0,$s1,main_done	# >100 ? ja, dann fertig

	move	$a0,$s0			# zu testende Zahl in $a0 als Argument laden
	jal	test_prime		# auf Primzahl testen
	beqz	$v0,main_loop		# nicht prim, also keine Bildschirmausgabe

	li	$v0,1			# Integer ausgeben
	syscall				# Hinweis: $a0 enthaelt bereits die Zahl !

	li	$v0,4			# Leerzeichen zur optischen Auflockerung ausgeben
	la	$a0,leerzeichen
	syscall

	j	main_loop		# naechster Schleifendurchlauf

main_done:
	li	$v0,10			# Programm beenden
	syscall



# #########################################################################################
# TEST_PRIME:
# UP, das eine einzelne Zahl testet, ob sie prim ist
#
# Parameter:   $a0 = zu testende Zahl
# Rckgabe:    $v0 = 1 wenn prim, 0 wenn nicht prim

test_prime:
	li	$v0,1			# davon ausgehen, dass Zahl prim ist

	move	$t0,$a0			# bei n beginnen
	li	$t1,1			# konstante Hilfsvariable,
					# fuer Schleifen und Vergleiche

test_prime_loop:
	sub	$t0,$t0,$t1		# sie ist sicher durch sich selbst teilbar, also
					# die naechstkleinere Zahl verwenden

	beq	$t0,$t1,test_prime_done # wenn 1 erreicht ist, dann UP beenden

	remu	$t2,$a0,$t0		# Rest der Division $a0/$t0 ermitteln
	bgtz	$t2,test_prime_loop	# wenn Rest existiert, dann ist $t0 kein Primfaktor
					# von $a0, also naechste Zahl untersuchen

	li	$v0,0			# doch Primfaktor gefunden => keine Primzahl
test_prime_done:
	jr	$ra			# UP beenden