# Aufgabe 35: Unterprogramme / Stack
#
# von: Stephan Brumme
#
# zuletzt geaendert: 07.Juni 2000

	.data

	.text
main:
	li	$a0,42			# zwei Werte auf den Stack legen
	jal	push
	li	$a0,23
	jal	push

	jal	pop			# und wieder auslesen
	jal	pop

	li	$v0,10			# Programm beenden
	syscall


# #########################################################################################
# POP:
# UP, das eine Zahl vom Stack holt
#
# Parameter:   keine
# Rckgabe:    $v0 = Zahl aus dem Stack
pop:
	add	$sp,$sp,4		# ein belegter Platz, d.h. 4 Byte, weniger im Stack
	lw	$v0,($sp)		# Zahl von den Stackspitze auslesen
	jr	$ra			# UP beenden


# #########################################################################################
# PUSH:
# UP, das eine Zahl auf den Stack legt
#
# Parameter:   $a0 = Zahl, die auf den Stack gelegt wird
push:
	sw	$a0,($sp)		# Element dort speichern
	add	$sp,$sp,-4		# Zeiger auf naechste freie Stelle weiterbewegen
	jr	$ra			# UP beenden